stages:
  - build
  - kaniko
  - env
  - test
  - staging
  - production

# build
build:
  stage: build
  script:
    - echo "This is some text" > my_file.txt
  artifacts:
    paths:
      - my_file.txt
    expire_in: 1 week
  # TODO: archive this file (https://docs.gitlab.com/ee/ci/pipelines/job_artifacts.html)

kaniko build:
  stage: kaniko
  script:
    - echo "filler text"
# END build

# test
env:
  stage: env
  script:
    - env
test:
  stage: test
  # TODO: color text (https://docs.gitlab.com/ee/ci/yaml/#coloring-script-output)
  before_script:
    - TXT_RED="" && TXT_CLEAR=""
    - echo "download stuff"
  script:
    - echo "dummy test"
    - echo -e "${TXT_RED}This text is red,${TXT_CLEAR} but this part isn't${TXT_RED} however this part is again."
# END test

# Stage deploy
staging deploy:
  stage: staging
  script:
    - echo "dummy deploy staging"
  after_script:
    - echo "dummy validate staging deploy"
# END stage deploy

# Prod deploy
production deploy:
  stage: production
  script:
    - echo "dummy deploy production"
  after_script:
    - echo "dummy validate production deploy"
# END prod deploy

post success:
  stage: .post
  script:
    - echo "notify success!"

post failure:
  stage: .post
  script:
    - echo "notify failure"

